Redmine - Defect #14015

Ruby hangs when adding a subtask
2013-05-08 16:03 - Ralf S.

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 232

Resolution: Fixed Affected version: 2.3.1
Description

We experience serious problems since updating from V2.3.0 => V2.3.1:

When adding a subtask, this process can take up to 3 minutes, where ruby produces 99% system load.

A similar effect can be seen, if adding 'related issues', ths takes up to 1 minute.

This bug might be related to the fixes for #13586

or to the current bug #13654

The defect currently makes our Redmine impossible to work with.

Does anybody see similar effects with V2.3.17?

Ralf

Related issues:

Related to Redmine - Defect #13654: Can't set parent issue when issue relatio... Closed
Related to Redmine - Defect #13914: Circular dependency issue when issue depe... Closed

Associated revisions

Revision 11827 - 2013-05-12 10:33 - Jean-Philippe Lang

Improved Issue#all_dependent_issues (#14015).

Patch by Jost Baron.

Revision 11828 - 2013-05-12 10:37 - Jean-Philippe Lang

Replaces camelcase variable names (#14015).

Revision 11829 - 2013-05-12 10:39 - Jean-Philippe Lang
Removes then's (#14015).

Revision 11830 - 2013-05-12 10:41 - Jean-Philippe Lang

Removes some empty lines (#14015).

Revision 11831 - 2013-05-12 10:42 - Jean-Philippe Lang

Replaces camelcase variable names (#14015).

Revision 11832 - 2013-05-12 10:45 - Jean-Philippe Lang
Check inclusion only once (#14015).

Revision 11833 - 2013-05-12 10:49 - Jean-Philippe Lang

Issue#children is never nil (#14015).

Revision 11996 - 2013-07-11 20:28 - Jean-Philippe Lang
Merged r11827 to r11833 from trunk (#14015).
https://www.redmine.org/issues/13586
https://www.redmine.org/issues/13654

History

#1 - 2013-05-08 16:11 - Toshi MARUYAMA
- Description updated

#2 - 2013-05-08 16:14 - Toshi MARUYAMA

- Category changed from Ruby support to Issues

#3 - 2013-05-08 17:55 - Jost Baron

I've looked into it and suspect that this is a problem with the method all_dependent_issues in issue.rb, Line 857. It uses a lot of recursive calls and
can probably be simplified.

#4 - 2013-05-10 01:19 - Jost Baron
- File all_dependend_issues.patch added

A patch for this issue is appended, based on revision 11811. It contains a much faster implementation of all_dependent_issues and some additional
tests for the method. The new implementation sometimes returns different results, but as far as | can jugde it, that happens due to bugs in the old
implementation.

#5 - 2013-05-10 05:26 - Toshi MARUYAMA

- Target version set to 2.3.2

#6 - 2013-05-13 19:15 - Jean-Philippe Lang

- Status changed from New to Resolved

Patch committed, thanks for your work.

#7 - 2013-06-10 13:13 - Jonathan Tee
- File issue13654.jpeg added
Hi,

i patched my redmine 2.3.1 with latest issue.rb http:/www.redmine.org/projects/redmine/repository/revisions/11833/entry/trunk/app/models/issue.rb,
now i am able to set a parent issue again (#13654) but now the icons are not corretly displayed for all subissues, see screenshot

#8 - 2013-06-11 11:46 - Jonathan Tee

some more details, see screenshot, issue 6293 was created with 2.3.1 without patch. Patch installed, issues 6295-8 were created without relation.
Then i set parent_id to 6294: Icons are missing.

#9 - 2013-06-19 16:34 - Jonathan Tee
- File screenshot.jpg added

forget my notes about missing icons. Now i've learned that icons are only displayed if the parent issue is above the issue. So if i sort on 'parent id' my
parent issue is the first and all my sub issues are displayed with icons :-)

#10 - 2013-07-11 20:29 - Jean-Philippe Lang
- Status changed from Resolved to Closed
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Merged in 2.3-stable, thanks for the feedback.

#11 - 2013-07-11 23:17 - Jared Fine

Huge thanks guys. We just upgraded our 1.4.4 install to 2.3.1 and were running into 100% CPU / RAM / swap usage, DB transaction locks, and what

looked like infinite loop situations. This looks to have resolved it.

#12 - 2013-07-25 22:13 - Marlon Pascoal

I'm facing this problem.

I've upgraded to 2.3.2 but the problem persists:
http://www.redmine.org/projects/redmine/repository/revisions/11833/entry/trunk/app/models/issue.rb
https://www.redmine.org/issues/13654

1. When I'm setting a child issue using the parent_issue_id on a issue that has some related issues | receive 'Parent task is invalid'

Thanks
